using System;
using System.Data;
using System.Data.Common;
using System.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Common.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Data.Configuration;
using Microsoft.Practices.EnterpriseLibrary.Data;

namespace DF.AsaDatabase
{
    /// <summary>
    /// Represents the process to build an instance of <see cref="AsaDatabase"/> described by configuration information.
    /// </summary>
    public class AsaDatabaseAssembler : IDatabaseAssembler
    {
        /// <summary>
        /// Builds an instance of <see cref="AsaDatabase"/>, based on the provided connection string.
        /// </summary>
        /// <param name="name">The name for the new database instance.</param>
        /// <param name="connectionStringSettings">The connection string for the new database instance.</param>
        /// <param name="configurationSource">The source for any additional configuration information.</param>
        /// <returns>The new Asa database instance.</returns>
        public Database Assemble(string name, ConnectionStringSettings connectionStringSettings, IConfigurationSource configurationSource)
        {
            return new AsaDatabase(connectionStringSettings.ConnectionString);
        }
    }
}
